//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CueList.h"
#include "Main.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TfrmCueList *frmCueList;
//---------------------------------------------------------------------
__fastcall TfrmCueList::TfrmCueList(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------

void TfrmCueList::ChangeCueIndex(void)
{
    if (lvIndex->Selected){
        Markers->Num = lvIndex->Selected->Index + 1;
        tPosition->Text = Markers->Position;
        tLength->Text = Markers->Length;
        tLabel->Text = Markers->Label;
        tNote->Text = Markers->Note;
        tText->Text = Markers->Text;
        btnDelete->Enabled = true;
        btnChange->Enabled = true;
    }else{
        tPosition->Text = "0";
        tLength->Text = "0";
        tLabel->Text = "";
        tNote->Text = "";
        tText->Text = "";
        btnDelete->Enabled = false;
        btnChange->Enabled = false;
    }
}
//---------------------------------------------------------------------

void TfrmCueList::ReloadCueList(void)
{
    lvIndex->Items->Clear();
    for (int i = 0;i<Markers->Count;i++){
        TListItem *li = lvIndex->Items->Add();
        li->Caption = AnsiString("Cue #") + AnsiString(i);
    }
    if (lvIndex->Items->Count>0) lvIndex->Items->Item[0]->Selected = true;
    ChangeCueIndex();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCueList::btnChangeClick(TObject *Sender)
{
    try{
        Markers->Position = tPosition->Text.ToInt();
    }catch(...){
        ShowMessage("Invalid Position Value");
        tPosition->SetFocus();
        return;
    }
    try{
        Markers->Length = tLength->Text.ToInt();
    }catch(...){
        ShowMessage("Invalid Length Value");
        tLength->SetFocus();
        return;
    }
    Markers->set_Label(StringToOleStr(tLabel->Text));
    Markers->set_Note(StringToOleStr(tNote->Text));
    Markers->set_Text(StringToOleStr(tText->Text));
}
//---------------------------------------------------------------------------

void __fastcall TfrmCueList::btnAddClick(TObject *Sender)
{
    try{
        tPosition->Text.ToInt();
    }catch(...){
        ShowMessage("Invalid Position Value");
        tPosition->SetFocus();
        return;
    }
    try{
        tLength->Text.ToInt();
    }catch(...){
        ShowMessage("Invalid Length Value");
        tLength->SetFocus();
        return;
    }
    Markers->Insert(tPosition->Text.ToInt(),
                                        tLength->Text.ToInt(),
                                        StringToOleStr(tLabel->Text),
                                        StringToOleStr(tNote->Text),
                                        StringToOleStr(tText->Text),
                                        -1,-1,-1,-1);
    ReloadCueList();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCueList::btnDeleteClick(TObject *Sender)
{
    Markers->Delete();
    ReloadCueList();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCueList::lvIndexSelectItem(TObject *Sender, TListItem *Item, bool Selected)
{
    ChangeCueIndex();    
}
//---------------------------------------------------------------------------

void __fastcall TfrmCueList::FormShow(TObject *Sender)
{
    Markers = frmMain->AudioEditor1->Markers;
    ReloadCueList();
}
//---------------------------------------------------------------------------

