//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Setup.h"
#include "Main.h"
#include <FileCtrl.hpp>
//---------------------------------------------------------------------
#pragma link "CSPIN"
#pragma resource "*.dfm"
TfrmOptions *frmOptions;
//--------------------------------------------------------------------- 
__fastcall TfrmOptions::TfrmOptions(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TfrmOptions::lstColorsClick(TObject *Sender)
{
    switch (lstColors->ItemIndex){
        case 0: ColorPanel->Color = (TColor)Colors->DigitalWaveform; break;
        case 1: ColorPanel->Color = (TColor)Colors->AnalogWaveform; break;
        case 2: ColorPanel->Color = (TColor)Colors->Background; break;
        case 3: ColorPanel->Color = (TColor)Colors->CenterLine; break;
        case 4: ColorPanel->Color = (TColor)Colors->SelectDigitalWaveform; break;
        case 5: ColorPanel->Color = (TColor)Colors->SelectAnalogWaveform; break;
        case 6: ColorPanel->Color = (TColor)Colors->SelectBackground; break;
        case 7: ColorPanel->Color = (TColor)Colors->SelectCenterLine; break;
        case 8: ColorPanel->Color = (TColor)Colors->Grid; break;
        case 9: ColorPanel->Color = (TColor)Colors->Cursor; break;
        case 10: ColorPanel->Color = (TColor)Colors->PlayCursor; break;
        case 11: ColorPanel->Color = (TColor)Colors->Boundary; break;
        case 12: ColorPanel->Color = (TColor)Colors->Scales; break;
        case 13: ColorPanel->Color = (TColor)Colors->Font; break;
        case 14: ColorPanel->Color = (TColor)Colors->CueMarker; break;
        case 15: ColorPanel->Color = (TColor)Colors->RangeMarker; break;
        case 16: ColorPanel->Color = (TColor)Colors->RangeMarkerBackground; break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::FormShow(TObject *Sender)
{
    Colors = frmMain->AudioEditor1->Colors;
    lstColors->ItemIndex = 0;
    lstColorsClick(Sender);
    spinBufSize->Value = frmMain->AudioEditor1->DeviceInput->BufferSize;
    spinBufCount->Value = frmMain->AudioEditor1->DeviceInput->BufferCount;
    spinBufTick->Value = frmMain->AudioEditor1->DeviceInput->TimerInterval;
    txtTempDir->Text = frmMain->AudioEditor1->TempDirectory;
    spinUndoRedo->Value = frmMain->AudioEditor1->UndoRedoCount;
    chSENAI->Checked = frmMain->AudioEditor1->FileInfo->SaveExtraInfoEnabled;

    chHSGrid->Checked = frmMain->AudioEditor1->ScaleY->Grid;
    chVSGrid->Checked = frmMain->AudioEditor1->ScaleX->Grid;
    chHSEnable->Checked = frmMain->AudioEditor1->ScaleX->Visible;
    chVSEnable->Checked = frmMain->AudioEditor1->ScaleY->Visible;

    rgBorder->ItemIndex = frmMain->AudioEditor1->TypeBorder;
    cmbHSType->ItemIndex = frmMain->AudioEditor1->ScaleX->Type - 1;
    cmbVSType->ItemIndex = frmMain->AudioEditor1->ScaleY->Type - 1;
    cmbVSOrien->ItemIndex = frmMain->AudioEditor1->ScaleY->Orientation - 1;

    chMarkerBarEnabled->Checked = frmMain->AudioEditor1->MarkerBarEnabled;
    chMarkerBkEnabled->Checked = frmMain->AudioEditor1->MarkerBackgroundEnabled;

    chSmooth->Checked = frmMain->AudioEditor1->Transform->SmoothEnabled;
    spinCrossfadeTime->Value = frmMain->AudioEditor1->Transform->SmoothTime;

    rgVisType->ItemIndex = frmMain->AudioEditor1->RecordVisualizationType - 1;
    chAccuEnabled->Checked = frmMain->AudioEditor1->Recorder->AccuEnabled;
    
    spinAttackTime->Value = frmMain->AudioEditor1->Recorder->AccuAttackTime;
    spinReleaseTime->Value = frmMain->AudioEditor1->Recorder->AccuReleaseTime;
    spinAttackLevel->Value = frmMain->AudioEditor1->Recorder->AccuAttackLevel;
    spinReleaseLevel->Value = frmMain->AudioEditor1->Recorder->AccuReleaseLevel;

    spinAGCLowLevel->Value = frmMain->AudioEditor1->Recorder->AGCLowLevel;
    spinAGCHighLevel->Value = frmMain->AudioEditor1->Recorder->AGCHighLevel;
    spinAGCRate->Value = frmMain->AudioEditor1->Recorder->AGCAttackTime;
    chAGCEnabled->Checked = frmMain->AudioEditor1->Recorder->AGCEnabled;
    
    chAGCEnabledClick(Sender);
    chAccuEnabledClick(Sender);
    chSmoothClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::btnChangeColorClick(TObject *Sender)
{
    if (ColorDialog1->Execute()){
        ColorPanel->Color = ColorDialog1->Color;
        switch (lstColors->ItemIndex){
            case 0: Colors->DigitalWaveform = ColorPanel->Color; break;
            case 1: Colors->AnalogWaveform = ColorPanel->Color; break;
            case 2: Colors->Background = ColorPanel->Color; break;
            case 3: Colors->CenterLine = ColorPanel->Color; break;
            case 4: Colors->SelectDigitalWaveform = ColorPanel->Color; break;
            case 5: Colors->SelectAnalogWaveform = ColorPanel->Color; break;
            case 6: Colors->SelectBackground = ColorPanel->Color; break;
            case 7: Colors->SelectCenterLine = ColorPanel->Color; break;
            case 8: Colors->Grid = ColorPanel->Color; break;
            case 9: Colors->Cursor = ColorPanel->Color; break;
            case 10: Colors->PlayCursor = ColorPanel->Color; break;
            case 11: Colors->Boundary = ColorPanel->Color; break;
            case 12: Colors->Scales = ColorPanel->Color; break;
            case 13: Colors->Font = ColorPanel->Color; break;
            case 14: Colors->CueMarker = ColorPanel->Color; break;
            case 15: Colors->RangeMarker = ColorPanel->Color; break;
            case 16: Colors->RangeMarkerBackground = ColorPanel->Color; break;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::btnChangeDirClick(TObject *Sender)
{
    AnsiString s = txtTempDir->Text;
    if (SelectDirectory(AnsiString("Select Temp Directory"),WideString(""),s)){
        frmMain->AudioEditor1->TempDirectory = s;
    }
    txtTempDir->Text = frmMain->AudioEditor1->TempDirectory;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chAGCEnabledClick(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AGCEnabled = chAGCEnabled->Checked;
    spinAGCRate->Enabled = chAGCEnabled->Checked;
    lblAGCRate->Enabled = chAGCEnabled->Checked;
    spinAGCLowLevel->Enabled = chAGCEnabled->Checked;
    lblAGCLowLevel->Enabled = chAGCEnabled->Checked;
    spinAGCHighLevel->Enabled = chAGCEnabled->Checked;
    lblAGCHighLevel->Enabled = chAGCEnabled->Checked;
    frmMain->btnAGC->Down = chAGCEnabled->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chAccuEnabledClick(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AccuEnabled = chAccuEnabled->Checked;
    
    gbRelease->Enabled = chAccuEnabled->Checked;
    gbAttack->Enabled = chAccuEnabled->Checked;

    spinAttackTime->Enabled = chAccuEnabled->Checked;
    spinAttackLevel->Enabled = chAccuEnabled->Checked;
    spinReleaseTime->Enabled = chAccuEnabled->Checked;
    spinReleaseLevel->Enabled = chAccuEnabled->Checked;

    lblAttackTime->Enabled = chAccuEnabled->Checked;
    lblAttackLevel->Enabled = chAccuEnabled->Checked;
    lblReleaseTime->Enabled = chAccuEnabled->Checked;
    lblReleaseLevel->Enabled = chAccuEnabled->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinBufSizeChange(TObject *Sender)
{
    frmMain->AudioEditor1->DeviceInput->BufferSize = spinBufSize->Value;
    frmMain->AudioEditor1->DeviceOutput->BufferSize = spinBufSize->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinBufCountChange(TObject *Sender)
{
    frmMain->AudioEditor1->DeviceInput->BufferCount = spinBufCount->Value;
    frmMain->AudioEditor1->DeviceOutput->BufferCount = spinBufCount->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinBufTickChange(TObject *Sender)
{
    frmMain->AudioEditor1->DeviceInput->TimerInterval = spinBufTick->Value;
    frmMain->AudioEditor1->DeviceOutput->TimerInterval = spinBufTick->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinUndoRedoChange(TObject *Sender)
{
    frmMain->AudioEditor1->UndoRedoCount = spinUndoRedo->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chSENAIClick(TObject *Sender)
{
    frmMain->AudioEditor1->FileInfo->SaveExtraInfoEnabled = chSENAI->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chHSEnableClick(TObject *Sender)
{
    frmMain->AudioEditor1->ScaleX->Visible = chHSEnable->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chHSGridClick(TObject *Sender)
{
    frmMain->AudioEditor1->ScaleX->Grid = chHSGrid->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chVSEnableClick(TObject *Sender)
{
    frmMain->AudioEditor1->ScaleY->Visible = chVSEnable->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chVSGridClick(TObject *Sender)
{
    frmMain->AudioEditor1->ScaleY->Grid = chVSGrid->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::cmbHSTypeClick(TObject *Sender)
{
     frmMain->AudioEditor1->ScaleX->Type = cmbHSType->ItemIndex + 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::cmbVSTypeClick(TObject *Sender)
{
    frmMain->AudioEditor1->ScaleY->Type = cmbVSType->ItemIndex + 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::cmbVSOrienClick(TObject *Sender)
{
    frmMain->AudioEditor1->ScaleY->Orientation = cmbVSOrien->ItemIndex + 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::rgBorderClick(TObject *Sender)
{
    frmMain->AudioEditor1->TypeBorder = rgBorder->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chMarkerBarEnabledClick(TObject *Sender)
{
    frmMain->AudioEditor1->MarkerBarEnabled = chMarkerBarEnabled->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chMarkerBkEnabledClick(TObject *Sender)
{
    frmMain->AudioEditor1->MarkerBackgroundEnabled = chMarkerBkEnabled->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::chSmoothClick(TObject *Sender)
{
    frmMain->AudioEditor1->Transform->SmoothEnabled = chSmooth->Checked;
    lblCrossfadeTimeMs->Enabled = chSmooth->Checked;
    lblCrossfadeTime->Enabled = chSmooth->Checked;
    spinCrossfadeTime->Enabled = chSmooth->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinCrossfadeTimeChange(TObject *Sender)
{
    frmMain->AudioEditor1->Transform->SmoothTime = spinCrossfadeTime->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinAttackTimeChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AccuAttackTime = spinAttackTime->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinAttackLevelChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AccuAttackLevel = spinAttackLevel->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinReleaseTimeChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AccuReleaseTime = spinReleaseTime->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinReleaseLevelChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AccuReleaseLevel = spinReleaseLevel->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinAGCLowLevelChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AGCLowLevel = spinAGCLowLevel->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinAGCHighLevelChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AGCHighLevel = spinAGCHighLevel->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::spinAGCRateChange(TObject *Sender)
{
    frmMain->AudioEditor1->Recorder->AGCAttackTime = spinAGCRate->Value;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::rgVisTypeClick(TObject *Sender)
{
    frmMain->AudioEditor1->RecordVisualizationType = rgVisType->ItemIndex + 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::btnHSFontClick(TObject *Sender)
{
    if (FontDialog1->Execute()){
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmOptions::btnVSFontClick(TObject *Sender)
{
    if (FontDialog1->Execute()){
    }    
}
//---------------------------------------------------------------------------

