using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestCSAudioEditor2
{
	public class formAdvanced : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ComboBox cmbAdvanced;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.ComponentModel.Container components = null;

		public formAdvanced(){ InitializeComponent(); }

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmbAdvanced = new System.Windows.Forms.ComboBox();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			this.SuspendLayout();
			// 
			// cmbAdvanced
			// 
			this.cmbAdvanced.Location = new System.Drawing.Point(16, 16);
			this.cmbAdvanced.Name = "cmbAdvanced";
			this.cmbAdvanced.Size = new System.Drawing.Size(152, 21);
			this.cmbAdvanced.TabIndex = 0;
			this.cmbAdvanced.Text = "comboBox1";
			this.cmbAdvanced.SelectedIndexChanged += new System.EventHandler(this.cmbAdvanced_SelectedIndexChanged);
			// 
			// trackBar1
			// 
			this.trackBar1.Location = new System.Drawing.Point(184, 16);
			this.trackBar1.Maximum = 65535;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(192, 42);
			this.trackBar1.TabIndex = 2;
			this.trackBar1.TickFrequency = 6000;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(208, 21);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(24, 16);
			this.checkBox1.TabIndex = 3;
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// formAdvanced
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(378, 55);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.checkBox1,
																		  this.trackBar1,
																		  this.cmbAdvanced});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "formAdvanced";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Advanced";
			this.Load += new System.EventHandler(this.Advanced_Load);
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		public string device;

		private void Advanced_Load(object sender, System.EventArgs e)
		{
			switch (device)
			{
				case "input":
					this.Text = (this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.Name + ": Advanced Properties";
					for (short i = 0; i < (this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.AdvancedCount + 1; i++)
						cmbAdvanced.Items.Add((this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.get_AdvancedName(i));
					break;
				case "output":
					this.Text = (this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.Name + ": Advanced Properties";
					for (short i = 0; i < (this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.AdvancedCount + 1; i++)
						cmbAdvanced.Items.Add((this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.get_AdvancedName(i));
					break;
			}
			cmbAdvanced.SelectedIndex = 0;
		}

		private void cmbAdvanced_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			object Val = null;
			switch (device)
			{
				case "input":
					Val = (this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.get_AdvancedValue((short)cmbAdvanced.SelectedIndex);
					break;
				case "output":
					Val = (this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.get_AdvancedValue((short)cmbAdvanced.SelectedIndex);
					break;
			}
			if (Val.GetType() == Type.GetType("System.Boolean"))
			{
				trackBar1.Visible = false;
				checkBox1.Visible = true;
				this.Width = 256;
				checkBox1.Checked = (bool)Val;
			}						
			else if (Val.GetType() == Type.GetType("System.Int64"))
			{
				trackBar1.Visible = true;
				checkBox1.Visible = false;
				this.Width = 384;
				trackBar1.Value = Math.Abs((int)Val);
			}
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			switch (device)
			{
				case "input":
					(this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.set_AdvancedValue((short)cmbAdvanced.SelectedIndex, checkBox1.Checked);
					checkBox1.Checked = (bool)(this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.get_AdvancedValue((short)cmbAdvanced.SelectedIndex);
					break;
				case "output":
					(this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.set_AdvancedValue((short)cmbAdvanced.SelectedIndex, checkBox1.Checked);
					checkBox1.Checked = (bool)(this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.get_AdvancedValue((short)cmbAdvanced.SelectedIndex);
					break;
			}
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			switch (device)
			{
				case "input":
					(this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.set_AdvancedValue((short)cmbAdvanced.SelectedIndex, trackBar1.Value);
					trackBar1.Value = Math.Abs((int)(this.Owner as formTestAE).AudioEditor.DeviceInput.DeviceLines.get_AdvancedValue((short)cmbAdvanced.SelectedIndex));
					break;
				case "output":
					(this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.set_AdvancedValue((short)cmbAdvanced.SelectedIndex, trackBar1.Value);
					trackBar1.Value = Math.Abs((int)(this.Owner as formTestAE).AudioEditor.DeviceOutput.DeviceLines.get_AdvancedValue((short)cmbAdvanced.SelectedIndex));
					break;
			}
		}
	}
}
