using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestCSAudioEditor2
{
	public class formMarkers : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.ColumnHeader ColumnHeader1;
		internal System.Windows.Forms.Button cmdDelete;
		internal System.Windows.Forms.ListView listMarkers;
		internal System.Windows.Forms.ColumnHeader ColumnHeader2;
		internal System.Windows.Forms.ColumnHeader ColumnHeader3;
		internal System.Windows.Forms.Button cmdAdd;
		private System.ComponentModel.Container components = null;

		public formMarkers()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ColumnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.cmdDelete = new System.Windows.Forms.Button();
			this.listMarkers = new System.Windows.Forms.ListView();
			this.ColumnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.ColumnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.cmdAdd = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// ColumnHeader1
			// 
			this.ColumnHeader1.Text = "ID";
			this.ColumnHeader1.Width = 40;
			// 
			// cmdDelete
			// 
			this.cmdDelete.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.cmdDelete.Location = new System.Drawing.Point(288, 38);
			this.cmdDelete.Name = "cmdDelete";
			this.cmdDelete.Size = new System.Drawing.Size(63, 24);
			this.cmdDelete.TabIndex = 5;
			this.cmdDelete.Text = "Delete";
			this.cmdDelete.Click += new System.EventHandler(this.cmdDelete_Click);
			// 
			// listMarkers
			// 
			this.listMarkers.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.listMarkers.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.ColumnHeader1,
																						  this.ColumnHeader2,
																						  this.ColumnHeader3});
			this.listMarkers.FullRowSelect = true;
			this.listMarkers.Location = new System.Drawing.Point(8, 8);
			this.listMarkers.MultiSelect = false;
			this.listMarkers.Name = "listMarkers";
			this.listMarkers.Size = new System.Drawing.Size(267, 246);
			this.listMarkers.TabIndex = 3;
			this.listMarkers.View = System.Windows.Forms.View.Details;
			this.listMarkers.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listMarkers_KeyDown);
			this.listMarkers.SelectedIndexChanged += new System.EventHandler(this.listMarkers_SelectedIndexChanged);
			// 
			// ColumnHeader2
			// 
			this.ColumnHeader2.Text = "Position";
			this.ColumnHeader2.Width = 100;
			// 
			// ColumnHeader3
			// 
			this.ColumnHeader3.Text = "Label";
			this.ColumnHeader3.Width = 120;
			// 
			// cmdAdd
			// 
			this.cmdAdd.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.cmdAdd.Location = new System.Drawing.Point(288, 8);
			this.cmdAdd.Name = "cmdAdd";
			this.cmdAdd.Size = new System.Drawing.Size(63, 24);
			this.cmdAdd.TabIndex = 4;
			this.cmdAdd.Text = "Add";
			this.cmdAdd.Click += new System.EventHandler(this.cmdAdd_Click);
			// 
			// formMarkers
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 261);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdDelete,
																		  this.listMarkers,
																		  this.cmdAdd});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "formMarkers";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Markers";
			this.Load += new System.EventHandler(this.formMarkers_Load);
			this.ResumeLayout(false);

		}
		#endregion

		public formTestAE frm;
		NCTAUDIOEDITOR2Lib.AudioEditor2Markers Markers;
		NCTAUDIOEDITOR2Lib.AudioEditor2Position Position;

		private void formMarkers_Load(object sender, System.EventArgs e)
		{
			Markers = frm.AudioEditor.Markers;
			Position = frm.AudioEditor.Position;
			ResetListMarkers();
		}

		private void ResetListMarkers()
		{
			ListViewItem Item;

			listMarkers.Items.Clear();

			for (int i = 1; i <= Markers.Count; i++)
			{
				Markers.Num = i;
				Item = listMarkers.Items.Add("[" + i.ToString() + "]");
				Item.SubItems.Add(Markers.Position.ToString());
				if (Markers.Length != 0)
					Item.SubItems[1].Text = Item.SubItems[1].Text + " To " + (Markers.Length + Markers.Position).ToString();
				Item.SubItems.Add(Markers.Label);
			}
		}

		private void listMarkers_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Markers.Num = listMarkers.SelectedItems[0].Index + 1;
			frm.AudioEditor.Position.GoToMarker(Markers.Num);
		}

		private void listMarkers_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Delete) 
			{
				Markers.Num = listMarkers.SelectedItems[0].Index + 1;
				Markers.Delete();
				ResetListMarkers();
			}
		}

		private void cmdAdd_Click(object sender, System.EventArgs e)
		{
			Markers.Insert(Position.StartSelect, Position.EndSelect - Position.StartSelect, "Marker " + (listMarkers.Items.Count + 1).ToString(), "", "", 0, 0, 0, 0);
			ResetListMarkers();
		}

		private void cmdDelete_Click(object sender, System.EventArgs e)
		{
			Markers.Delete();
			ResetListMarkers();
		}
	}
}
