unit CueList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, NCTAUDIOEDITOR2Lib_TLB;

type
  TfrmCueList = class(TForm)
    btnChange: TButton;
    btnDelete: TButton;
    btnAdd: TButton;
    tPosition: TEdit;
    tLength: TEdit;
    tLabel: TEdit;
    tNote: TEdit;
    tText: TEdit;
    Label18: TLabel;
    Label17: TLabel;
    Label16: TLabel;
    Label15: TLabel;
    Label14: TLabel;
    lvIndex: TListView;
    procedure btnChangeClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure lvIndexSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Markers: IAudioEditor2Markers;
    procedure ChangeCueIndex;
    procedure ReloadCueList;
  end;

var
  frmCueList: TfrmCueList;

implementation

uses Main;

{$R *.dfm}
//---------------------------------------------------------------------

procedure TfrmCueList.ChangeCueIndex;
begin
    if (lvIndex.Selected <> nil) then begin
        Markers.Num := lvIndex.Selected.Index + 1;
        tPosition.Text := IntToStr(Markers.Position);
        tLength.Text := IntToStr(Markers.Length);
        tLabel.Text := Markers.Label_;
        tNote.Text := Markers.Note;
        tText.Text := Markers.Text;
        btnDelete.Enabled := True;
        btnChange.Enabled := True;
    end else begin
        tPosition.Text := '0';
        tLength.Text := '0';
        tLabel.Text := '';
        tNote.Text := '';
        tText.Text := '';
        btnDelete.Enabled := False;
        btnChange.Enabled := False;
    end;
end;
//---------------------------------------------------------------------

procedure TfrmCueList.ReloadCueList;
var
    i: Integer;
    li: TListItem;
begin
    lvIndex.Items.Clear();
    for i := 0 to Markers.Count - 1 do begin
        li := lvIndex.Items.Add();
        li.Caption := 'Cue #' + IntToStr(i);
    end;
    if (lvIndex.Items.Count>0) then lvIndex.Items.Item[0].Selected := True;
    ChangeCueIndex();
end;
//---------------------------------------------------------------------------

procedure TfrmCueList.btnChangeClick(Sender: TObject);
begin
    try
        Markers.Position := StrToInt(tPosition.Text);
    except
        ShowMessage('Invalid Position Value');
        tPosition.SetFocus();
        Exit;
    end;
    try
        Markers.Length := StrToInt(tLength.Text);
    except
        ShowMessage('Invalid Length Value');
        tLength.SetFocus();
        Exit;
    end;
    Markers.set_Label_(StringToOleStr(tLabel.Text));
    Markers.set_Note(StringToOleStr(tNote.Text));
    Markers.set_Text(StringToOleStr(tText.Text));
end;
//---------------------------------------------------------------------------

procedure TfrmCueList.btnAddClick(Sender: TObject);
begin
    try
        Markers.Position := StrToInt(tPosition.Text);
    except
        ShowMessage('Invalid Position Value');
        tPosition.SetFocus();
        Exit;
    end;
    try
        Markers.Length := StrToInt(tLength.Text);
    except
        ShowMessage('Invalid Length Value');
        tLength.SetFocus();
        Exit;
    end;
    Markers.Insert(StrToInt(tPosition.Text),
                                        StrToInt(tLength.Text),
                                        StringToOleStr(tLabel.Text),
                                        StringToOleStr(tNote.Text),
                                        StringToOleStr(tText.Text),
                                        -1,-1,-1,-1);
    ReloadCueList();
end;
//---------------------------------------------------------------------------

procedure TfrmCueList.btnDeleteClick(Sender: TObject);
begin
    Markers.Delete();
    ReloadCueList();
end;
//---------------------------------------------------------------------------

procedure TfrmCueList.lvIndexSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
    ChangeCueIndex();    
end;
//---------------------------------------------------------------------------

procedure TfrmCueList.FormShow(Sender: TObject);
begin
    Markers := frmMain.AudioEditor1.Markers;
    ReloadCueList;
end;
//---------------------------------------------------------------------------
end.
