// TestVCAudioEditorView.cpp : implementation of the CTestVCAudioEditorView class
//

#include "stdafx.h"
#include "TestVCAudioEditor.h"

#include "TestVCAudioEditorDoc.h"
#include "TestVCAudioEditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestVCAudioEditorView

IMPLEMENT_DYNCREATE(CTestVCAudioEditorView, CView)

BEGIN_MESSAGE_MAP(CTestVCAudioEditorView, CView)
	//{{AFX_MSG_MAP(CTestVCAudioEditorView)
	ON_WM_SIZE()
	ON_COMMAND(ID_NEW, OnNew)
	ON_COMMAND(ID_OPEN, OnOpen)
	ON_COMMAND(ID_COPY, OnCopy)
	ON_COMMAND(ID_CUT, OnCut)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_COMMAND(ID_SAVE_SEL, OnSaveSelect)
	ON_COMMAND(ID_UNDO, OnUndo)
	ON_COMMAND(ID_PASTE, OnPaste)
	ON_COMMAND(ID_ZOOMFULL, OnZoomFull)
	ON_COMMAND(ID_ZOOMIN, OnZoomIn)
	ON_COMMAND(ID_ZOOMOUT, OnZoomOut)
	ON_COMMAND(ID_REDO, OnRedo)
	ON_COMMAND(ID_REVERSE, OnReverse)
	ON_COMMAND(ID_RECORD, OnRecord)
	ON_COMMAND(ID_STOP, OnStop)
	ON_COMMAND(ID_PLAY, OnPlay)
	ON_COMMAND(ID_PAUSE, OnPause)
	ON_COMMAND(ID_NORMALIZE, OnNormalize)
	ON_COMMAND(ID_INVERT, OnInvert)
	ON_COMMAND(ID_FADE1, OnFadeIn)
	ON_COMMAND(ID_FADE2, OnFadeOut)
	ON_COMMAND(ID_AMP1, OnAmpIn)
	ON_COMMAND(ID_AMP2, OnAmpOut)
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_VIEW_SPECTRALVIEW, OnViewSpectralview)
	ON_COMMAND(ID_VIEW_WAVEFORMVIEW, OnViewWaveformview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WAVEFORMVIEW, OnUpdateViewWaveformview)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SPECTRALVIEW, OnUpdateViewSpectralview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestVCAudioEditorView construction/destruction

CTestVCAudioEditorView::CTestVCAudioEditorView()
{
	m_TypeView=1;

}

CTestVCAudioEditorView::~CTestVCAudioEditorView()
{
}

BOOL CTestVCAudioEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTestVCAudioEditorView drawing

void CTestVCAudioEditorView::OnDraw(CDC* pDC)
{
	CTestVCAudioEditorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CTestVCAudioEditorView diagnostics

#ifdef _DEBUG
void CTestVCAudioEditorView::AssertValid() const
{
	CView::AssertValid();
}

void CTestVCAudioEditorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestVCAudioEditorDoc* CTestVCAudioEditorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestVCAudioEditorDoc)));
	return (CTestVCAudioEditorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestVCAudioEditorView message handlers

void CTestVCAudioEditorView::OnInitialUpdate() 
{
	CFrameWnd* pf = STATIC_DOWNCAST(CFrameWnd,GetParentFrame());
	m_frame = DYNAMIC_DOWNCAST(CMainFrame,pf);
	CView::OnInitialUpdate();
	
	BOOL res;

	m_frame->m_wndStatusBar.SetPaneInfo(0,ID_INDICATOR_I1,SBPS_STRETCH,100);
	m_frame->m_wndStatusBar.SetPaneInfo(1,ID_INDICATOR_I2,SBPS_STRETCH,100);
	m_frame->m_wndStatusBar.SetPaneInfo(2,ID_INDICATOR_I3,SBPS_NORMAL,110);
	m_frame->m_wndStatusBar.SetPaneInfo(3,ID_INDICATOR_I4,SBPS_NORMAL,110);
	m_frame->m_wndStatusBar.SetPaneInfo(4,ID_INDICATOR_I5,SBPS_NORMAL,110);
	
	RECT rect,rect1;
	GetClientRect(&rect);

	rect1 = rect;

	rect.bottom -= 10;
	rect1.top=rect.bottom;

	CoInitialize(NULL);
	
	res = m_ax.CreateControl( CLSID_AudioEditor2,NULL, WS_VISIBLE, rect, this, 1);
	
	IUnknown *unk;	
	unk = m_ax.GetControlUnknown();
	res = unk->QueryInterface(&Editor);
	unk->Release();
	unk = NULL;

	IConnectionPointContainer* pContainer = NULL;
	IConnectionPoint* pCP = NULL;
	DWORD dwAdvise = 0;
	
	EditorCallback = new CEditorCallback;
	EditorCallback->AddRef();
	
	Editor->QueryInterface(IID_IConnectionPointContainer, (void**)&pContainer) ;
	res = pContainer->FindConnectionPoint(DIID__IAudioEditor2Events,&pCP);	
	res = pCP->Advise(EditorCallback,&dwAdvise);
	
	pContainer->Release();
	pContainer = NULL;
	pCP->Release();
	pCP = NULL;

	EditorCallback->TestView = this;

	res = Progress.Create(WS_VISIBLE, rect1,this, 2);
	Progress.SetRange(0,100);
	Progress.SetPos(0);
	

	IAudioEditor2Device* Dev;

	Editor->get_DeviceOutput(&Dev);
	Dev->Num = 0;
	Dev->Release();
	Dev = NULL;

	Editor->get_DeviceInput(&Dev);
	Dev->Num = 0;
	Dev->Release();
	Dev = NULL;

	flgPause = false;
	ClearParam();
}

void CTestVCAudioEditorView::OnDestroy() 
{
	EditorCallback->Release();
	EditorCallback = NULL;

	CView::OnDestroy();
	
	m_ax.DestroyWindow();
	CoUninitialize();	
}

void CTestVCAudioEditorView::OnSize(UINT nType, int cx, int cy) 
{
	if (cx<40)cx=40;
	if (cy<25)cy=25;
	CView::OnSize(nType, cx, cy);

	if( m_ax ) { 
		RECT rect,rect1;
		GetClientRect(&rect);

		rect1=rect;

		rect.bottom-=10;
		rect1.top=rect.bottom;

		m_ax.MoveWindow(&rect);
		Progress.MoveWindow(&rect1);
	}
	ShowScrollBar(SB_BOTH,0);
	
}

void CTestVCAudioEditorView::OnNew() 
{
	Editor->New(FQ_44_KHZ,STEREO);
	
	fName="New WAV file";
	ShowParam();
}

void CTestVCAudioEditorView::OnOpen() 
{
	CString szFilter = "Wav files (*.wav)|*.wav|Mp3 files (*.mp3)|*.mp3|Dialogic ADPCM files (*.vox)|*.vox|Ogg Vorbis files (*.ogg)|*.ogg|Window Media files (*.wma)|*.wma|CD track (*.cda)|*.cda|";
	CFileDialog getFile(TRUE,NULL,NULL,
						OFN_HIDEREADONLY |
						OFN_OVERWRITEPROMPT |
						OFN_FILEMUSTEXIST, szFilter);
	if(getFile.DoModal() != IDOK) return;
	UpdateWindow( );
	fName = getFile.GetPathName();
	
	Editor->Open(fName.AllocSysString(),DEFAULT);
	ShowParam();	
}

void CTestVCAudioEditorView::OnCopy() 
{
	Editor->Copy();	
}

void CTestVCAudioEditorView::OnCut() 
{
	Editor->Cut();	
}

void CTestVCAudioEditorView::OnSave() 
{
	CString szFilter = "Wav files (*.wav)|*.wav|Mp3 files (*.mp3)|*.mp3|Dialogic ADPCM files (*.vox)|*.vox|Ogg Vorbis files (*.ogg)|*.ogg|Window Media files (*.wma)|*.wma|CD track (*.cda)|*.cda|";
	CFileDialog getFile(FALSE,NULL,NULL,
						OFN_PATHMUSTEXIST|
						OFN_OVERWRITEPROMPT,szFilter);
	if(getFile.DoModal() != IDOK) return;
	UpdateWindow( );
	fName=getFile.GetPathName();
	
	Editor->Save(fName.AllocSysString(),FALSE,DEFAULT);
	ShowParam();
}

void CTestVCAudioEditorView::OnSaveSelect() 
{
	CString szFilter = "Wav files (*.wav)|*.wav|Mp3 files (*.mp3)|*.mp3|Dialogic ADPCM files (*.vox)|*.vox|Ogg Vorbis files (*.ogg)|*.ogg|Window Media files (*.wma)|*.wma|CD track (*.cda)|*.cda|";
	CFileDialog getFile(FALSE,NULL,NULL,
						OFN_PATHMUSTEXIST|
						OFN_OVERWRITEPROMPT,szFilter);
	if(getFile.DoModal() != IDOK) return;
	UpdateWindow( );
	fName=getFile.GetPathName();
	
	Editor->Save(fName.AllocSysString(),TRUE,DEFAULT);
	ShowParam();
}

void CTestVCAudioEditorView::OnUndo() 
{
	Editor->Undo();	
}

void CTestVCAudioEditorView::OnPaste() 
{
	Editor->Paste();	
}

void CTestVCAudioEditorView::ShowParam()
{
	IAudioEditor2FileInfo* Info;
	Editor->get_FileInfo(&Info);

	IAudioEditor2Position* Pos;
	Editor->get_Position(&Pos);


	m_frame->m_wndStatusBar.SetPaneText(1,(char*)Info->FormatString);
	m_frame->m_wndStatusBar.SetPaneText(0, fName);

	CString str;
	str.Format("nSamples: %d",Pos->TotalSamples);
	m_frame->m_wndStatusBar.SetPaneText(3,str); 

	str.Format("Time: %.2f sec", Pos->SamplesToSec(Pos->TotalSamples)/1000.);
	m_frame->m_wndStatusBar.SetPaneText(4,str); 


	Info->Release();
	Info = NULL;
	Pos->Release();
	Pos = NULL;

	AfxGetMainWnd()->SetWindowText("Test VC++ NCTAudioEditor2 ActiveX DLL"); 

}

void CTestVCAudioEditorView::ClearParam()
{
	m_frame->m_wndStatusBar.SetPaneText(0," "); 
	m_frame->m_wndStatusBar.SetPaneText(1," "); 
	m_frame->m_wndStatusBar.SetPaneText(2," "); 
	m_frame->m_wndStatusBar.SetPaneText(3," "); 
	m_frame->m_wndStatusBar.SetPaneText(4," "); 

	AfxGetMainWnd()->SetWindowText("NCTAudioEditor Control - Test MS VC++ 6.0");  
}

void CTestVCAudioEditorView::OperationBlock(long Percent)
{
	Progress.SetPos(Percent);
}

void CTestVCAudioEditorView::EndOperation()
{
	Progress.SetPos(0);
}

void CTestVCAudioEditorView::OnZoomFull() 
{
	Editor->ZoomFull();	
}

void CTestVCAudioEditorView::OnZoomIn() 
{
	Editor->ZoomIn();	
}

void CTestVCAudioEditorView::OnZoomOut() 
{
	Editor->ZoomOut();
}

void CTestVCAudioEditorView::OnRedo() 
{
	Editor->Redo();	
}

void CTestVCAudioEditorView::OnReverse() 
{
	Editor->Transform->Reverse();
}

void CTestVCAudioEditorView::OnRecord() 
{
	Editor->Record(RECORD_MIX);	
}

void CTestVCAudioEditorView::OnStop() 
{
	Editor->Stop();
	flgPause = false;
}

void CTestVCAudioEditorView::OnPlay() 
{
	if (!flgPause) Editor->Play(NORMALPLAY);
	else { Editor->Continue(); flgPause = false; }
}

void CTestVCAudioEditorView::OnPause() 
{
	if (!flgPause) { Editor->Pause(); flgPause = true; }
	else { Editor->Continue(); flgPause = false; }
}

void CTestVCAudioEditorView::OnNormalize() 
{
	Editor->Transform->Normalize(80,TRUE);	
}

void CTestVCAudioEditorView::OnInvert() 
{
	Editor->Transform->Invert();	
}

void CTestVCAudioEditorView::OnFadeIn() 
{
	Editor->Transform->Fade(0,100);	
}

void CTestVCAudioEditorView::OnFadeOut() 
{
	Editor->Transform->Fade(100,0);	
}

void CTestVCAudioEditorView::OnAmpIn() 
{
	Editor->Transform->Amplify(120);	
}

void CTestVCAudioEditorView::OnAmpOut() 
{
	Editor->Transform->Amplify(80);	
}

BOOL CTestVCAudioEditorView::OnEraseBkgnd(CDC* pDC) 
{
//	return 0;
	
	return CView::OnEraseBkgnd(pDC);
}

void CTestVCAudioEditorView::OnViewSpectralview() 
{
	m_TypeView=2;
	Editor->put_TypeView(SPECTRAL);
}

void CTestVCAudioEditorView::OnViewWaveformview() 
{
	m_TypeView=1;
	Editor->put_TypeView(WAVEFORM);	
}

void CTestVCAudioEditorView::OnUpdateViewWaveformview(CCmdUI* pCmdUI) 
{
	if (m_TypeView==1)pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CTestVCAudioEditorView::OnUpdateViewSpectralview(CCmdUI* pCmdUI) 
{
	if (m_TypeView==2)pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}
