// TestVCAudioEditorView.h : interface of the CTestVCAudioEditorView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTVCAUDIOEDITORVIEW_H__538A3011_0690_4F85_9382_B3DD4F12BB91__INCLUDED_)
#define AFX_TESTVCAUDIOEDITORVIEW_H__538A3011_0690_4F85_9382_B3DD4F12BB91__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#import "C:\Program Files\NCT\AudioEditor2\Redist\NCTAudioEditor2.dll"  no_namespace named_guids

#include "MainFrm.h"

class CTestVCAudioEditorView;

class CEditorCallback : public _IAudioEditor2Events  
{
public:
	CTestVCAudioEditorView* TestView;
	CEditorCallback(){m_cnt=0;}
	virtual ~CEditorCallback(){}
    STDMETHOD(GetTypeInfoCount)(UINT*) { return E_NOTIMPL; }
    STDMETHOD(GetTypeInfo)(UINT, LCID, ITypeInfo**) { return E_NOTIMPL; }
    STDMETHOD(GetIDsOfNames)(REFIID, LPOLESTR*, UINT, LCID, DISPID*) { return E_NOTIMPL; }

    STDMETHOD(Invoke)(DISPID dispIdMember, 	REFIID	riid, LCID	lcid, WORD	wFlags, DISPPARAMS*	pDispParams, 
	VARIANT*	pVarResult, EXCEPINFO*	pExcepInfo, UINT*	puArgErr);//{ return(S_OK);}
    STDMETHOD(QueryInterface)(REFIID iid, LPVOID* ppv) { 
        if ((iid == __uuidof(_IAudioEditor2Events)) ||
        (iid == __uuidof(IDispatch)) ||
        (iid == __uuidof(IUnknown)))
            *ppv = this;
        else {
            *ppv = 0;
            return E_NOINTERFACE;
        }
        AddRef();
        return S_OK;
    }
    
	STDMETHOD_(ULONG,AddRef)() { 
		return InterlockedIncrement(&m_cnt); 
	}

    STDMETHOD_(ULONG,Release)() { 
	    InterlockedDecrement(&m_cnt);
		if (m_cnt!=0) return m_cnt;
		delete this;
		return 0;
    }
protected:
	LONG   m_cnt;
private:
};


class CTestVCAudioEditorView : public CView
{
protected: // create from serialization only
	CTestVCAudioEditorView();
	DECLARE_DYNCREATE(CTestVCAudioEditorView)

// Attributes
public:
	CTestVCAudioEditorDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestVCAudioEditorView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	void EndOperation();
	void OperationBlock(long Percent);
	virtual ~CTestVCAudioEditorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTestVCAudioEditorView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnNew();
	afx_msg void OnOpen();
	afx_msg void OnCopy();
	afx_msg void OnCut();
	afx_msg void OnSave();
	afx_msg void OnSaveSelect();
	afx_msg void OnUndo();
	afx_msg void OnPaste();
	afx_msg void OnZoomFull();
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnRedo();
	afx_msg void OnReverse();
	afx_msg void OnRecord();
	afx_msg void OnStop();
	afx_msg void OnPlay();
	afx_msg void OnPause();
	afx_msg void OnNormalize();
	afx_msg void OnInvert();
	afx_msg void OnFadeIn();
	afx_msg void OnFadeOut();
	afx_msg void OnAmpIn();
	afx_msg void OnAmpOut();
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnViewSpectralview();
	afx_msg void OnViewWaveformview();
	afx_msg void OnUpdateViewWaveformview(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewSpectralview(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool flgPause;
	int m_TypeView;
	CProgressCtrl Progress;
	CEditorCallback* EditorCallback;
	void ClearParam();
	void ShowParam();
	CWnd m_ax;
	IAudioEditor2* Editor;
	CString fName;
	CMainFrame* m_frame;
};

#ifndef _DEBUG  // debug version in TestVCAudioEditorView.cpp
inline CTestVCAudioEditorDoc* CTestVCAudioEditorView::GetDocument()
   { return (CTestVCAudioEditorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTVCAUDIOEDITORVIEW_H__538A3011_0690_4F85_9382_B3DD4F12BB91__INCLUDED_)
